##############################################################################
##
## Zen_PowerShell_Script_strings.psd1
##
## by Actian Corporation (http://www.actian.com/zen)
##
## Localized strings for Actian Zen PowerShell scripts.
##
##############################################################################
@{
    ## Information message strings.    
    infoRunning="Running {0} {1}..."
    infoLooking="...looking for installed {0} product."
    infoZenInfo="...found version {0} installed."
    infoVisualStudioInfo="...found Visual Studio version '{0}' at '{1}'."
    infoInstallingVsixPkg="...please wait, importing VS Extension package for PSQL ADO.NET Provider Data Tools."
    infoInstalledVsixPkgLatestWithLog="   ...import complete, see the log file %temp%\{0} for details."
    infoInstalledVsixPkgLatestNoLog="   ...import complete."
    infoRemovingVsixPkg="...please wait, removing VS Extension package for PSQL ADO.NET Provider Data Tools."
    infoRemovedVsixPkgLatestWithLog="   ...removal complete, see {0} in %temp% folder for details."
    infoRemovedVsixPkgLatestNoLog="   ...removal complete."
    infoAddedModelFirstIncludeTemplates="...successfully imported the Entity Framework Model First include templates."
    infoAddedModelFirstT4Templates="...successfully imported the Entity Framework Model First T4 templates."
    infoRemovedModelFirstIncludeTemplates="...successfully removed the Entity Framework Model First include templates."
    infoRemovedModelFirstT4Templates="...successfully removed the Entity Framework Model First T4 templates."
    infoEnd="Finished running {0} {1}!"
    
    ## Warning message strings.
    warnNoTemplates="WARNING: The script was unable to copy the Model First templates to the Entity Framework Tools folder ({0})."
    
    ## Error message strings.
    errMustBeAdmin="ERROR: The current Windows PowerShell session is not running as Administrator. Start Windows PowerShell by  using the Run as Administrator option, and then try running the script again."
    errMustBePS64onWin64="ERROR: The current Windows PowerShell session is a 32-bit process. On 64-bit Windows, please run the install from a 64-bit PowerShell process."
    errNoZenFound="ERROR: Unable to locate Zen installed on the target system. Please install Zen and then restart the PSQL ADO.NET Provider Data Tools installation."
    errWrongZenVer="ERROR: The PSQL ADO.NET Provider Data Tools installation requires Zen v{0}.x or later.  Please install Zen v{0}.x or later and then restart the PSQL ADO.NET Provider Data Tools installation."
    errNoVSFound="ERROR: Unable to locate the install folder for Visual Studio.  Please verify Visual Studio {0} or later is installed and restart this script."
    errNoVSIXInstaller="ERROR: Unable to locate the Visual Studio VSIXInstaller utility. The PSQL ADO.NET Provider Data Tools VSIX package cannot be imported into Visual Studio."
    errVsixInstallWithLog="ERROR: Unable to import the PSQL ADO.NET Provider Data Tools VSIX package into Visual Studio. Check the contents of log file located in the TEMP folder{0}."
    errVsixInstallNoLog="ERROR: Unable to import the PSQL ADO.NET Provider Data Tools VSIX package into Visual Studio."
    errVsixUninstallWithLog="ERROR: Unable to remove the PSQL ADO.NET Provider Data Tools VSIX package from Visual Studio. Check the contents of log file located in the TEMP folder{0}."
    errVsixUninstallNoLog="ERROR: Unable to remove the PSQL ADO.NET Provider Data Tools VSIX package from Visual Studio."
    errUnknown="ERROR: The script encountered an unknown error and will now exit."
}
# SIG # Begin signature block
# MIIZeQYJKoZIhvcNAQcCoIIZajCCGWYCAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQUOvPryo+m5oIxDML01De589DZ
# JhWgghQ5MIIE0DCCA7igAwIBAgIBBzANBgkqhkiG9w0BAQsFADCBgzELMAkGA1UE
# BhMCVVMxEDAOBgNVBAgTB0FyaXpvbmExEzARBgNVBAcTClNjb3R0c2RhbGUxGjAY
# BgNVBAoTEUdvRGFkZHkuY29tLCBJbmMuMTEwLwYDVQQDEyhHbyBEYWRkeSBSb290
# IENlcnRpZmljYXRlIEF1dGhvcml0eSAtIEcyMB4XDTExMDUwMzA3MDAwMFoXDTMx
# MDUwMzA3MDAwMFowgbQxCzAJBgNVBAYTAlVTMRAwDgYDVQQIEwdBcml6b25hMRMw
# EQYDVQQHEwpTY290dHNkYWxlMRowGAYDVQQKExFHb0RhZGR5LmNvbSwgSW5jLjEt
# MCsGA1UECxMkaHR0cDovL2NlcnRzLmdvZGFkZHkuY29tL3JlcG9zaXRvcnkvMTMw
# MQYDVQQDEypHbyBEYWRkeSBTZWN1cmUgQ2VydGlmaWNhdGUgQXV0aG9yaXR5IC0g
# RzIwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQC54MsQ1K92vdSTYusw
# ZLiBCGzDBNliF44v/z5lz4/OYuY8UhzaFkVLVat4a2ODYpDOD2lsmcgaFItMzEUz
# 6ojcnqOvK/6AYZ15V8TPLvQ/MDxdR/yaFrzDN5ZBUY4RS1T4KL7QjL7wMDge87Am
# +GZHY23ecSZHjzhHU9FGHbTj3ADqRay9vHHZqm8A29vNMDp5T19MR/gd71vCxJ1g
# O7GyQ5HYpDNO6rPWJ0+tJYqlxvTV0KaudAVkV4i1RFXULSo6Pvi4vekyCgKUZMQW
# OlDxSq7neTOvDCAHf+jfBDnCaQJsY1L6d8EbyHSHyLmTGFBUNUtpTrw700kuH9zB
# 0lL7AgMBAAGjggEaMIIBFjAPBgNVHRMBAf8EBTADAQH/MA4GA1UdDwEB/wQEAwIB
# BjAdBgNVHQ4EFgQUQMK9J47MNIMwojPX+2yz8LQsgM4wHwYDVR0jBBgwFoAUOpqF
# BxBnKLbv9r0FQW4gwZTaD94wNAYIKwYBBQUHAQEEKDAmMCQGCCsGAQUFBzABhhho
# dHRwOi8vb2NzcC5nb2RhZGR5LmNvbS8wNQYDVR0fBC4wLDAqoCigJoYkaHR0cDov
# L2NybC5nb2RhZGR5LmNvbS9nZHJvb3QtZzIuY3JsMEYGA1UdIAQ/MD0wOwYEVR0g
# ADAzMDEGCCsGAQUFBwIBFiVodHRwczovL2NlcnRzLmdvZGFkZHkuY29tL3JlcG9z
# aXRvcnkvMA0GCSqGSIb3DQEBCwUAA4IBAQAIfmyTEMg4uJapkEv/oV9PBO9sPpyI
# BslQj6Zz91cxG7685C/b+LrTW+C05+Z5Yg4MotdqY3MxtfWoSKQ7CC2iXZDXtHwl
# TxFWMMS2RJ17LJ3lXubvDGGqv+QqG+6EnriDfcFDzkSnE3ANkR/0yBOtg2DZ2HKo
# cyQetawiDsoXiWJYRBuriSUBAA/NxBti21G00w9RKpv0vHP8ds42pM3Z2Czqrpv1
# KrKQ0U11GIo/ikGQI31bS/6kA1ibRrLDYGCD+H1QQc7CoZDDu+8CL9IVVO5EFdkK
# rqeKM+2xLXY2JtwE65/3YR8V3Idv7kaWKK2hJn0KCacuBKONvPi8BDABMIIE/jCC
# A+agAwIBAgIQDUJK4L46iP9gQCHOFADw3TANBgkqhkiG9w0BAQsFADByMQswCQYD
# VQQGEwJVUzEVMBMGA1UEChMMRGlnaUNlcnQgSW5jMRkwFwYDVQQLExB3d3cuZGln
# aWNlcnQuY29tMTEwLwYDVQQDEyhEaWdpQ2VydCBTSEEyIEFzc3VyZWQgSUQgVGlt
# ZXN0YW1waW5nIENBMB4XDTIxMDEwMTAwMDAwMFoXDTMxMDEwNjAwMDAwMFowSDEL
# MAkGA1UEBhMCVVMxFzAVBgNVBAoTDkRpZ2lDZXJ0LCBJbmMuMSAwHgYDVQQDExdE
# aWdpQ2VydCBUaW1lc3RhbXAgMjAyMTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCC
# AQoCggEBAMLmYYRnxYr1DQikRcpja1HXOhFCvQp1dU2UtAxQtSYQ/h3Ib5FrDJbn
# GlxI70Tlv5thzRWRYlq4/2cLnGP9NmqB+in43Stwhd4CGPN4bbx9+cdtCT2+anaH
# 6Yq9+IRdHnbJ5MZ2djpT0dHTWjaPxqPhLxs6t2HWc+xObTOKfF1FLUuxUOZBOjdW
# htyTI433UCXoZObd048vV7WHIOsOjizVI9r0TXhG4wODMSlKXAwxikqMiMX3MFr5
# FK8VX2xDSQn9JiNT9o1j6BqrW7EdMMKbaYK02/xWVLwfoYervnpbCiAvSwnJlaeN
# svrWY4tOpXIc7p96AXP4Gdb+DUmEvQECAwEAAaOCAbgwggG0MA4GA1UdDwEB/wQE
# AwIHgDAMBgNVHRMBAf8EAjAAMBYGA1UdJQEB/wQMMAoGCCsGAQUFBwMIMEEGA1Ud
# IAQ6MDgwNgYJYIZIAYb9bAcBMCkwJwYIKwYBBQUHAgEWG2h0dHA6Ly93d3cuZGln
# aWNlcnQuY29tL0NQUzAfBgNVHSMEGDAWgBT0tuEgHf4prtLkYaWyoiWyyBc1bjAd
# BgNVHQ4EFgQUNkSGjqS6sGa+vCgtHUQ23eNqerwwcQYDVR0fBGowaDAyoDCgLoYs
# aHR0cDovL2NybDMuZGlnaWNlcnQuY29tL3NoYTItYXNzdXJlZC10cy5jcmwwMqAw
# oC6GLGh0dHA6Ly9jcmw0LmRpZ2ljZXJ0LmNvbS9zaGEyLWFzc3VyZWQtdHMuY3Js
# MIGFBggrBgEFBQcBAQR5MHcwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3NwLmRpZ2lj
# ZXJ0LmNvbTBPBggrBgEFBQcwAoZDaHR0cDovL2NhY2VydHMuZGlnaWNlcnQuY29t
# L0RpZ2lDZXJ0U0hBMkFzc3VyZWRJRFRpbWVzdGFtcGluZ0NBLmNydDANBgkqhkiG
# 9w0BAQsFAAOCAQEASBzctemaI7znGucgDo5nRv1CclF0CiNHo6uS0iXEcFm+FKDl
# J4GlTRQVGQd58NEEw4bZO73+RAJmTe1ppA/2uHDPYuj1UUp4eTZ6J7fz51Kfk6ft
# Q55757TdQSKJ+4eiRgNO/PT+t2R3Y18jUmmDgvoaU+2QzI2hF3MN9PNlOXBL85zW
# envaDLw9MtAby/Vh/HUIAHa8gQ74wOFcz8QRcucbZEnYIpp1FUL1LTI4gdr0YKK6
# tFL7XOBhJCVPst/JKahzQ1HavWPWH1ub9y4bTxMd90oNcX6Xt/Q/hOvB46NJofrO
# p79Wz7pZdmGJX36ntI5nePk2mOHLKNpbh6aKLzCCBSowggQSoAMCAQICCCb6uKSN
# FCdLMA0GCSqGSIb3DQEBCwUAMIG0MQswCQYDVQQGEwJVUzEQMA4GA1UECBMHQXJp
# em9uYTETMBEGA1UEBxMKU2NvdHRzZGFsZTEaMBgGA1UEChMRR29EYWRkeS5jb20s
# IEluYy4xLTArBgNVBAsTJGh0dHA6Ly9jZXJ0cy5nb2RhZGR5LmNvbS9yZXBvc2l0
# b3J5LzEzMDEGA1UEAxMqR28gRGFkZHkgU2VjdXJlIENlcnRpZmljYXRlIEF1dGhv
# cml0eSAtIEcyMB4XDTIwMDQxMzIwMDc0MVoXDTIzMDQxMzIwMDc0MVowbDELMAkG
# A1UEBhMCVVMxDjAMBgNVBAgTBVRleGFzMRMwEQYDVQQHEwpSb3VuZCBSb2NrMRsw
# GQYDVQQKExJBY3RpYW4gQ29ycG9yYXRpb24xGzAZBgNVBAMTEkFjdGlhbiBDb3Jw
# b3JhdGlvbjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALyocy/QINa6
# HjQBRinT3Gq+AgGqcJwsbsA/K5ZELJgmTuO4XIbSm/pK2DKhj0/KPu62GR2CzOaM
# Wc2aHCt1k6BA2f4mVdQYhh1VF2Awc0WFhLKdISJQeKY2m+bYxxBWa0BmK6/O6R11
# nn0w6N2fiMs/CSoA8Xkug8Ee+oFMB8Pgct4TFU/xFu7TP7kCIXpWNc2blMoAWLFq
# TWv3DfCbiZmlgHnI8YeD5PPneOk7P9h/A1+sdfU6PzE6z/R1+wi6OI2U/TzkDYVx
# F7+LMUZaxpDP+KIWUDwwKLLYNWxIuM4MrZ/skEewc/DFzgYRbrGxWTsytLqrOnuB
# AhMHMYAEFNkCAwEAAaOCAYUwggGBMAwGA1UdEwEB/wQCMAAwEwYDVR0lBAwwCgYI
# KwYBBQUHAwMwDgYDVR0PAQH/BAQDAgeAMDUGA1UdHwQuMCwwKqAooCaGJGh0dHA6
# Ly9jcmwuZ29kYWRkeS5jb20vZ2RpZzJzNS01LmNybDBdBgNVHSAEVjBUMEgGC2CG
# SAGG/W0BBxcCMDkwNwYIKwYBBQUHAgEWK2h0dHA6Ly9jZXJ0aWZpY2F0ZXMuZ29k
# YWRkeS5jb20vcmVwb3NpdG9yeS8wCAYGZ4EMAQQBMHYGCCsGAQUFBwEBBGowaDAk
# BggrBgEFBQcwAYYYaHR0cDovL29jc3AuZ29kYWRkeS5jb20vMEAGCCsGAQUFBzAC
# hjRodHRwOi8vY2VydGlmaWNhdGVzLmdvZGFkZHkuY29tL3JlcG9zaXRvcnkvZ2Rp
# ZzIuY3J0MB8GA1UdIwQYMBaAFEDCvSeOzDSDMKIz1/tss/C0LIDOMB0GA1UdDgQW
# BBQwB/xOgqq0irDx1sDDAdjdl8kxIjANBgkqhkiG9w0BAQsFAAOCAQEAXPCXCcUa
# Mshqi7pczfhn5VbNDv4wEvcdsLFdCIgFhSQehsjdEelL9hrwrlfQZNag6UK5eavs
# zK81RzUKmNS49S48dQDhpp+3B9jDmyIIed8wop6T+B9z50vmJ6+nvlZd7ylvYef3
# v47q2m1PiUPBu4fXNEL8LjD66s7Iw5yjy1g0e5k0VXhSc4i6BacdGZ4V2z0a2Q1g
# Jky/PGnKKyqI0iPOzU6X1E9iTEKKN6Gw7lrOb1uCQlEa9TTJDMVi2I5EkEjHHE24
# mNdqqh05cF/8AmwWXBG5U3iI5414F21ibgUElxguFZdQJTOID6TxHYyfcnurBXcH
# EJSK9Dp8MWB77zCCBTEwggQZoAMCAQICEAqhJdbWMht+QeQF2jaXwhUwDQYJKoZI
# hvcNAQELBQAwZTELMAkGA1UEBhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZ
# MBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTEkMCIGA1UEAxMbRGlnaUNlcnQgQXNz
# dXJlZCBJRCBSb290IENBMB4XDTE2MDEwNzEyMDAwMFoXDTMxMDEwNzEyMDAwMFow
# cjELMAkGA1UEBhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcGA1UECxMQ
# d3d3LmRpZ2ljZXJ0LmNvbTExMC8GA1UEAxMoRGlnaUNlcnQgU0hBMiBBc3N1cmVk
# IElEIFRpbWVzdGFtcGluZyBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoC
# ggEBAL3QMu5LzY9/3am6gpnFOVQoV7YjSsQOB0UzURB90Pl9TWh+57ag9I2ziOSX
# v2MhkJi/E7xX08PhfgjWahQAOPcuHjvuzKb2Mln+X2U/4Jvr40ZHBhpVfgsnfsCi
# 9aDg3iI/Dv9+lfvzo7oiPhisEeTwmQNtO4V8CdPuXciaC1TjqAlxa+DPIhAPdc9x
# ck4Krd9AOly3UeGheRTGTSQjMF287DxgaqwvB8z98OpH2YhQXv1mblZhJymJhFHm
# gudGUP2UKiyn5HU+upgPhH+fMRTWrdXyZMt7HgXQhBlyF/EXBu89zdZN7wZC/aJT
# Kk+FHcQdPK/P2qwQ9d2srOlW/5MCAwEAAaOCAc4wggHKMB0GA1UdDgQWBBT0tuEg
# Hf4prtLkYaWyoiWyyBc1bjAfBgNVHSMEGDAWgBRF66Kv9JLLgjEtUYunpyGd823I
# DzASBgNVHRMBAf8ECDAGAQH/AgEAMA4GA1UdDwEB/wQEAwIBhjATBgNVHSUEDDAK
# BggrBgEFBQcDCDB5BggrBgEFBQcBAQRtMGswJAYIKwYBBQUHMAGGGGh0dHA6Ly9v
# Y3NwLmRpZ2ljZXJ0LmNvbTBDBggrBgEFBQcwAoY3aHR0cDovL2NhY2VydHMuZGln
# aWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJlZElEUm9vdENBLmNydDCBgQYDVR0fBHow
# eDA6oDigNoY0aHR0cDovL2NybDQuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJl
# ZElEUm9vdENBLmNybDA6oDigNoY0aHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0Rp
# Z2lDZXJ0QXNzdXJlZElEUm9vdENBLmNybDBQBgNVHSAESTBHMDgGCmCGSAGG/WwA
# AgQwKjAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cuZGlnaWNlcnQuY29tL0NQUzAL
# BglghkgBhv1sBwEwDQYJKoZIhvcNAQELBQADggEBAHGVEulRh1Zpze/d2nyqY3qz
# eM8GN0CE70uEv8rPAwL9xafDDiBCLK938ysfDCFaKrcFNB1qrpn4J6JmvwmqYN92
# pDqTD/iy0dh8GWLoXoIlHsS6HHssIeLWWywUNUMEaLLbdQLgcseY1jxk5R9IEBhf
# iThhTWJGJIdjjJFSLK8pieV4H9YLFKWA1xJHcLN11ZOFk362kmf7U2GJqPVrlsD0
# WGkNfMgBsbkodbeZY4UijGHKeZR+WfyMD+NvtQEmtmyl7odRIeRYYJu6DC0rbaLE
# frvEJStHAgh8Sa4TtuF8QkIoxhhWz0E0tmZdtnR79VYzIi8iNrJLokqV2PWmjlIx
# ggSqMIIEpgIBATCBwTCBtDELMAkGA1UEBhMCVVMxEDAOBgNVBAgTB0FyaXpvbmEx
# EzARBgNVBAcTClNjb3R0c2RhbGUxGjAYBgNVBAoTEUdvRGFkZHkuY29tLCBJbmMu
# MS0wKwYDVQQLEyRodHRwOi8vY2VydHMuZ29kYWRkeS5jb20vcmVwb3NpdG9yeS8x
# MzAxBgNVBAMTKkdvIERhZGR5IFNlY3VyZSBDZXJ0aWZpY2F0ZSBBdXRob3JpdHkg
# LSBHMgIIJvq4pI0UJ0swCQYFKw4DAhoFAKCBijAZBgkqhkiG9w0BCQMxDAYKKwYB
# BAGCNwIBBDAcBgorBgEEAYI3AgELMQ4wDAYKKwYBBAGCNwIBFTAjBgkqhkiG9w0B
# CQQxFgQUhyL6f7ZtEFHLZ1E0WcelFNi2J4swKgYKKwYBBAGCNwIBDDEcMBqhGIAW
# aHR0cDpcXHd3dy5hY3RpYW4uY29tIDANBgkqhkiG9w0BAQEFAASCAQCZqjpwh/9S
# UEbx73CicMezvUBdenpKHIRGfFJOo6kGaHJw+HTRx1j0x77ZrH0RAVgw+hZbG83F
# /c79PVthHCvCuzfr3MWV53ThuxUiKYDk1uB2hU+P6Lmjse6cpDdMvL4ZOxzo1GXW
# 5z7sIrDiqfbR92WXEx5M0QgrPhE4T0jKkuIdWEJ3Et0MFFEGzPjVPnj4W/F/K1xU
# 0fUDgvtsWdkZjrsFUxWiDptRGY11+T11YlEcXNGWG5J3eSXBZOLDlwOd3wnc3/17
# WPbT4V8TBHokhTYN2rGtpRx0jK82HPVIit6hCyZh0y1Qe9vOHB/LnYuRMwGK+CbV
# VWlQMaTrrO1YoYICMDCCAiwGCSqGSIb3DQEJBjGCAh0wggIZAgEBMIGGMHIxCzAJ
# BgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5k
# aWdpY2VydC5jb20xMTAvBgNVBAMTKERpZ2lDZXJ0IFNIQTIgQXNzdXJlZCBJRCBU
# aW1lc3RhbXBpbmcgQ0ECEA1CSuC+Ooj/YEAhzhQA8N0wDQYJYIZIAWUDBAIBBQCg
# aTAYBgkqhkiG9w0BCQMxCwYJKoZIhvcNAQcBMBwGCSqGSIb3DQEJBTEPFw0yMTEw
# MDcyMjA5MzNaMC8GCSqGSIb3DQEJBDEiBCCPH8q+I8BHLPisM43xUwbhxG36xe6U
# AxhNs7ZpeckXJTANBgkqhkiG9w0BAQEFAASCAQBQ8wigmrUR0UnQfjLFdu0B7uHX
# XHjpWJ4qnt67HOS6kbeVKq2oeENuf1QzhbaRretfIWRtOWKCGJM+nDdcV3ZqpnTh
# eNF0bqcdASMT+z0khaUXQ+LbMOpQd9tyggxs6SQ3AdjvU81CWjItdyBPAN3TJeMW
# pQ1NlHMpLeKgbcLH6qloRIH0uzQzZ3XKD8/gmIPEcijUxkU8CDPDqp9bygW7S5F+
# MUSr7OMcbspcKvzrkEryb2NchWxOC+H2s9AcQmxctRkNT8M1QaMYJxZzDFjsj5eI
# KolAXBfPO4uTzHZzaONUJxAED2zI5/Lk24TiEFQxQpq8qW3e6L3ALRnV4u2f
# SIG # End signature block
